 

This code is a numerical implementation of the BARBI
   (BARotropic-Baroclinic-Interaction) model.

There is no restriction to usage, no copyright, feel free to test.
However, this software is provided with absolutely NO WARRANTY.

A description and evaluation of BARBI can be found 
in Olbers and Eden, 2002, submitted to JPO.

Documentation and code can be downloaded at
http://www.phys.ocean.dal.ca/~ceden/BARBI.html

Note that this code is mainly based on GFDL MOM 2.1,
from which most of the structure and numerics are taken.

To compile, edit the Makefile and type make.
The NetCDF library (version >3) will be linked for all 
I/O purposes, which can be accessed at 
http://www.unidata.ucar.edu/packages/netcdf
if not installed at the system.

To run the model, type ./barbi.x < namelist .
The model output will be written in a NetCDF file, which
can be viewed using various programs, e.g. ferret, matlab, grads.

Most configuration changes can be done by editing the file
barbi_template.F and by changing the namelist input.

If there are any problems, bugs or serious errors,
please let me know.

Files:

Makefile            : the makefile
README              : this file
barbi.F             : main driver
barbi_clinic.F      : baroclinic part of BARBI
barbi_diag.F        : subroutines for diagnosing
barbi_module.F      : the main (fortran 90) module
barbi_setup.F       : configuration of BARBI
barbi_template.F    : configuration dependent stuff
barbi_tropic.F      : barotropic part of BARBI
congrad_module.F    : conjugate gradient solver, taken from GFDL/MOM2.1
island_module.F     : island perimeter mapping routines for the solver
namelist            : sample namelist input 
time_type.F         : fortran 90 module used by tmngr.F
tmngr.F             : time manager routines


C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)

c
c-----------------------------------------------------------------------
c     file contains main module containing all global variables
c
c-----------------------------------------------------------------------
c
      module  barbi_module
c=======================================================================
c     global variables and arrays for BARBI
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use time_manager_module
      implicit none
c
      real (kind=8), parameter :: version = 1.0 ! version number
c
c     physical constants
c
      real(kind=8) :: h_0    ! max. water depth in m
      real(kind=8) :: rho0   ! reference density in kg/m^3
      real(kind=8) :: radius ! mean radius of earth in m
      real(kind=8) :: omega  ! earth rotation frequency in s
      real(kind=8) :: pi     ! 3.14...
c
c     model parameter
c
      integer      :: imt,jmt,n_order !  size of domain, number of moments
      real(kind=8) :: N0,N0sqr        ! stability freq. and square of it
      real(kind=8) :: Am,Ah,Av        ! hor. visc./diff. and vert. visc. in m^2/s
      real(kind=8), allocatable :: gamma(:,:,:) ! truncation parameter
      real(kind=8), allocatable :: gscal(:,:)   ! scaling for barocl. modes
      real(kind=8) :: eps_solver   = 1.0        ! convergence crit. for streamfct.
      real(kind=8) :: eps_solver_p = 1e-6       ! convergence crit for bottom press.
      real(kind=8) :: time_step  ! time step in seconds
      real(kind=8) :: runlen     ! length of experiment in days
      real(kind=8) :: snapint    ! snapshot interval in days
      integer      :: jlat0      ! reference latitude for beta/f plane
c
c     grid and related variables, see MOM 2.1/2.2/3.0 Manual for explanation
c
      real(kind=8),allocatable :: xt(:), yt(:), xu(:), yu(:)
      real(kind=8),allocatable :: dxtdeg(:), dytdeg(:) 
      real(kind=8),allocatable :: dxudeg(:), dyudeg(:)
      real(kind=8),allocatable :: dxt(:), dyt(:), dxu(:), dyu(:)
      real(kind=8),allocatable :: dytr(:),dyt2r(:),dyur(:), dyu2r(:)
      real(kind=8),allocatable :: dxtr(:),dxt2r(:),dxur(:), dxu2r(:)
      real(kind=8),allocatable :: phi(:),phit(:),cst(:),csu(:),sine(:)
      real(kind=8),allocatable :: cstr(:),csur(:),tng(:)
      real(kind=8),allocatable :: cstdytr(:), cstdyt2r(:)
      real(kind=8),allocatable :: csudyur(:),csudyu2r(:)
      real(kind=8),allocatable :: cst_dytr(:),csu_dyur(:)
      real(kind=8),allocatable :: dus(:),dun(:),duw(:),due(:),dxmetr(:)
c
c     land mask
c
      real(kind=8),allocatable :: tmask(:,:),umask(:,:)
c
c     (inverse of) topography
c
      real(kind=8),allocatable :: h(:,:),hu(:,:),hr(:,:),hur(:,:)
c
c     coriolis parameter
c
      real(kind=8),allocatable :: cori(:,:,:)
c
c     short hands for mixing parameter
c
      real(kind=8),allocatable :: am3(:),am4(:,:)
      real(kind=8),allocatable :: ahc_north(:),ahc_south(:)
      real(kind=8),allocatable :: amc_north(:),amc_south(:)
c
c     coefficients to minimize advection and diffusion computation 
c
      real(kind=8),allocatable :: csudxur(:,:),csudxu2r(:,:)
      real(kind=8),allocatable :: cstdxtr(:,:),cstdxt2r(:,:)
      real(kind=8),allocatable :: am_csudxtr(:,:), ah_cstdxur(:,:)
c
c     advection velocity on northern and eastern face of "T" cells 
c
      real(kind=8),allocatable :: adv_vnt(:,:), adv_vet(:,:)
c
c     pressure gradient and so on
c
      real(kind=8),allocatable :: zu(:,:,:), grad_E(:,:,:), press(:,:)
      real(kind=8),allocatable :: psi(:,:,:),dpsi(:,:),guess(:,:)
c
c     forcing of the momentum
c
      real(kind=8),allocatable :: wind(:,:,:)
c
c     the barotropic velocities
c
      real(kind=8),allocatable :: u(:,:,:,:)
c
c     the baroclinic velocities
c
      real(kind=8),allocatable :: ub(:,:,:,:,:)
c
c     the moments of the vertical integrated density
c
      real(kind=8),allocatable :: g(:,:,:,:)
c
c     some switches for configurations
c
      logical :: cyclic           = .false.   ! cyclic boundary conditions if true
      logical :: enable_obc_north = .false.   ! open northern boundary
      logical :: enable_obc_south = .false.   ! south
      logical :: enable_obc_west  = .false.   ! western 
      logical :: enable_obc_east  = .false.   ! eastern
      logical :: enable_beta_plane  = .false. ! use beta plane approx
      logical :: enable_f_plane     = .false. ! f-plane
c
c     diagnostics
c
      logical :: read_restart  = .false. ! read from restart file at begin of run
      logical :: write_restart = .true.  ! write to restart file at end of run
      logical :: write_modes   = .true. ! write baroclinic modes instead of density moments
      character (len=80):: snap_file,restart_file ! filenames for snapshots and restart
      integer :: mscans    ! iteration needed for poisson solver (streamfct)
      integer :: mscans_p  ! same but solving for bottom press
      real(kind=8)    :: ek,ke ! barotrop. kinetic energy, pot energy

      contains

      subroutine  init_barbi_module
c=======================================================================
c     Read in namelist parameter and initialize all arrays in module 
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      implicit none
      namelist /barbi/ 
     &     imt,jmt,n_order,
     &     time_step,
     &     ah,am,Av,N0,runlen,snapint,
     &     snap_file,write_modes,
     &     eps_solver, eps_solver_p,
     &     read_restart,write_restart,restart_file,
     &     cyclic, 
     &     enable_obc_north, enable_obc_south, 
     &     enable_obc_west,  enable_obc_east, 
     &     enable_beta_plane, enable_f_plane,jlat0

      read(5, nml = barbi)
c
c     truncation parameter
c
      allocate( gamma(imt,jmt,n_order) )
      allocate( gscal(n_order/2+1,n_order/2+1) ); gscal = 0.

c     grid
      allocate( xt(imt), yt(jmt), xu(imt), yu(jmt))
      allocate( dxtdeg(imt), dytdeg(jmt), dxudeg(imt), dyudeg(jmt))
      allocate( dxt(imt), dyt(jmt), dxu(imt), dyu(jmt))
      allocate( dytr(jmt),dyt2r(jmt), dyur(jmt),dyu2r(jmt))
      allocate( phi(jmt),phit(jmt), cst(jmt),csu(jmt),sine(jmt))
      allocate( cstr(jmt),csur(jmt),tng(jmt))
      allocate( cstdytr(jmt), cstdyt2r(jmt),csudyur(jmt),csudyu2r(jmt))
      allocate( cst_dytr(jmt),csu_dyur(jmt))
      allocate( dus(jmt),dun(jmt))
      allocate( dxtr(imt),dxt2r(imt),dxur(imt), dxu2r(imt))
      allocate( dxmetr(imt),duw(imt),due(imt))
c     land mask
      allocate( tmask(imt,jmt),umask(imt,jmt) )
      allocate( h(imt,jmt),hu(imt,jmt), hr(imt,jmt),hur(imt,jmt) )
c     coriolis parameter
      allocate( cori(imt,jmt,2) )
c     mixing parameter
      allocate( am3(jmt),am4(jmt,2) )
      allocate( amc_north(jmt),amc_south(jmt) )
      allocate( ahc_north(jmt),ahc_south(jmt) )
c     coefficients to minimize advection and diffusion computation 
      allocate( csudxur(imt,jmt),csudxu2r(imt,jmt),am_csudxtr(imt,jmt) )
      allocate( cstdxtr(imt,jmt),cstdxt2r(imt,jmt),ah_cstdxur(imt,jmt) )
c     advection velocity on northern and eastern face of "T" cells 
      allocate( adv_vet(imt,jmt), adv_vnt(imt,jmt) )
c     pressure gradient and so on
      allocate( zu(imt,jmt,2) )
      allocate( grad_E(imt,jmt,2) )
      allocate( press(imt,jmt))
      allocate( psi(imt,jmt,2),dpsi(imt,jmt),guess(imt,jmt) )
      guess=0.;dpsi=0.
c     forcing of the velocity
      allocate( wind(imt,jmt,2) )
c     the barotropic velocities
      allocate( u(imt,jmt,2,0:2) )
c     the baroclinic velocities
      allocate( ub(imt,jmt,2,0:2,0:n_order) )
c     the moments of the vertical integrated density
      allocate( g(imt,jmt,0:n_order,0:2) )

      end subroutine init_barbi_module

      end module barbi_module

c
c-----------------------------------------------------------------------
c     file contains diagnostic part for BARBI
c-----------------------------------------------------------------------
c
      subroutine diagi()
c=======================================================================
c     Initialization of diagnostics for BARBI
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      call def_snap
      end subroutine diagi


      subroutine diag()
c=======================================================================
c     diagnose BARBI
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      integer i,j
      real (kind=8) :: fxa,fxb,uarea,tarea
c
      if (snapshot_time_step) then
c
c      compute basin averaged Ekin and Epot
c
       ke=0.; ek=0.
       do j=2,jmt-1
        fxa=  csu(j)*dyu(j)
        fxb=  cst(j)*dyt(j)
        do i=2,imt-1
         uarea=fxa*dxu(i)*umask(i,j)
         tarea=fxb*dxt(i)*tmask(i,j)
         ke=ke+(u(i,j,1,tau)**2+u(i,j,2,tau)**2)/2.*hu(i,j)*uarea
         ek=ek+g(i,j,1,tau)*tarea
        enddo
       enddo
c
c      print that out
c
       write(6,'(a,i5,a,e8.2,a,e8.2,a,i5,a,i5)') 
     &  'itt=',itt
     &  ,' kin.en.=',ke
     &  ,' pot.en.=',ek
     &  ,' psi_itts:',mscans
     &  ,' P_itts:',mscans_p
c
c      write NetCDF snpshot
c
       call snapit()
c
      endif
      end subroutine diag


      subroutine snapit()
c=======================================================================
c     Append a snapshot to NetCDF file
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      real (kind=4) :: var(imt,jmt),spval=-9.9e12,tt,vv
      integer ncid,tauxid,tauyid,gid,psiid,pressid,fid
      integer uid,vid,ubid,vbid,ekid,keid,timeid,timedim
      integer iret,old_mode,len,n,nn
      integer, dimension(4) :: dims, corner, edges
      include "netcdf.inc"

      iret=nf_open(snap_file,NF_WRITE,ncid)
      iret=nf_set_fill(ncid, NF_NOFILL, old_mode)
c
c     get the id of all variables
c
      iret=nf_inq_varid(ncid,'taux',tauxid)
      iret=nf_inq_varid(ncid,'tauy',tauyid)
      iret=nf_inq_varid(ncid,'G',Gid)
      iret=nf_inq_varid(ncid,'u',uid)
      iret=nf_inq_varid(ncid,'v',vid)
      iret=nf_inq_varid(ncid,'f',fid)
      iret=nf_inq_varid(ncid,'P',pressid)
      iret=nf_inq_varid(ncid,'psi',psiid)
      iret=nf_inq_varid(ncid,'ub',ubid)
      iret=nf_inq_varid(ncid,'vb',vbid)
      iret=nf_inq_varid(ncid,'ek',ekid)
      iret=nf_inq_varid(ncid,'ke',keid)
      iret=nf_inq_dimid(ncid,'Time',timedim)
      iret=nf_inq_varid(ncid,'Time',timeid)
c
c     append time  and zero dim. variables
c
      iret=nf_inq_dimlen(ncid, timedim,len)
      if (iret.ne.0) print*,nf_strerror(iret)
      len=len+1
      tt=float(itt)*dt/60./60./24.
      iret= nf_put_vara_real (ncid,timeid,len,1,tt)
      vv=ke
      iret= nf_put_vara_real (ncid,keid,len,1,vv)
      vv=ek
      iret= nf_put_vara_real (ncid,ekid,len,1,vv)
c
c     append 2-dim variables
c
      Corner = (/1,1,len,1/)
      edges =  (/imt,jmt,1,1/)
c
      var=u(:,:,1,tau)*hu
      where( umask == 0. ) var = spval
      iret= nf_put_vara_real (ncid,uid , corner, edges,var)
c
      var=u(:,:,2,tau)*hu
      where( umask == 0. ) var = spval
      iret= nf_put_vara_real (ncid,vid , corner, edges,var)
c
      var=press(:,:)
      where( tmask == 0. ) var = spval
      iret= nf_put_vara_real (ncid,pressid , corner, edges,var)
c
      var=psi(:,:,1)/1e6
      where( tmask == 0. ) var = spval
      iret= nf_put_vara_real (ncid,psiid , corner, edges,var)
c
      var=wind(:,:,2)*rho0
      where( umask == 0. ) var = spval
      iret= nf_put_vara_real (ncid,tauyid , corner, edges,var)
c
      var=wind(:,:,1)*rho0
      where( umask == 0. ) var = spval
      iret= nf_put_vara_real (ncid,tauxid , corner, edges,var)
c
c     append 3-dim variables
c       write either raw vertical density/vel. modes or 
c       flat bottom baroclinic modes
c
      do n=1,n_order,2

       Corner = (/1,1,n/2+1,len/)
       edges =  (/imt,jmt,1,1/)
       if (write_modes) then
        var=0.
        do nn=1,n_order,2
         var=var+gscal(n/2+1,nn/2+1)*g(:,:,nn,tau)/h**(nn-1)
        enddo
       else
        where (tmask==1) var=g(:,:,n,tau)/h**(n-1)
       endif
       where( tmask == 0. ) var = spval
       iret= nf_put_vara_real (ncid,Gid , corner, edges,var)

       if (write_modes) then
        var=0.
        do nn=1,n_order,2
c        do not know if this is correct but it works for now
         var=var+gscal(n/2+1,nn/2+1)*ub(:,:,1,tau,nn)/hu**(nn-1)
     &             /(nn+1)
        enddo
       else
        where (umask==1) var=ub(:,:,1,tau,n)/hu**(n-1)
       endif
       where( umask == 0. ) var = spval
       iret= nf_put_vara_real (ncid,ubid , corner, edges,var)
c
       if (write_modes) then
        var=0.
        do nn=1,n_order,2
         var=var+gscal(n/2+1,nn/2+1)*ub(:,:,2,tau,nn)/hu**(nn-1)
     &             /(nn+1)
        enddo
       else
        where (umask==1) var=ub(:,:,2,tau,n)/hu**(n-1)
       endif
       where( umask == 0. ) var = spval
       iret= nf_put_vara_real (ncid,vbid , corner, edges,var)
c
      enddo
      call ncclos (ncid, iret)
      end subroutine  snapit


      subroutine def_snap()
c=======================================================================
c     define a netCDF file for output
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      include "netcdf.inc"
      integer, dimension(4) :: dims, corner, edges
      character (len=80) :: name, unit, text
      real (kind=4) :: spval=-9.9e12,var(imt,jmt)
      integer ncid,tauxid,tauyid,gid,psiid,pressid,fid
      integer uid,vid,ubid,vbid,ekid,keid,timeid
      integer lon_tdim,lon_udim,lat_tdim,lat_udim,timedim
      integer lon_tid,lon_uid,lat_tid,lat_uid,topoid,topouid
      integer iret,old_mode,ilen, order_dim,order_id,k
       
      ncid = nccre (snap_file, NCCLOB, iret)
      iret=nf_set_fill(ncid, NF_NOFILL, old_mode)
c
c     define dimensions
c
      lon_tdim  = ncddef(ncid, 'Longitude_t', imt, iret)
      Lon_udim  = ncddef(ncid, 'Longitude_u', imt, iret)
      Lat_tdim  = ncddef(ncid, 'Latitude_t',  jmt, iret)
      Lat_udim  = ncddef(ncid, 'Latitude_u',  jmt, iret)
      order_dim = ncddef(ncid, 'Order',  n_order/2+1, iret)
      Timedim   = ncddef(ncid, 'Time', nf_unlimited, iret)
c
c     define variables
c
      Lon_tid  = ncvdef (ncid,'Longitude_t',NCFLOAT,1,lon_tdim,iret)
      Lon_uid  = ncvdef (ncid,'Longitude_u',NCFLOAT,1,lon_udim,iret)
      Lat_tid  = ncvdef (ncid,'Latitude_t', NCFLOAT,1,lat_tdim,iret)
      Lat_uid  = ncvdef (ncid,'Latitude_u', NCFLOAT,1,lat_udim,iret)
      order_id = ncvdef (ncid,'Order', NCFLOAT,1,order_dim,iret)
      Timeid   = ncvdef(ncid,'Time',   NCFLOAT,1,timedim,iret)
c
      dims    = (/Lon_tdim,lat_tdim,timedim,0/)
      psiid   = ncvdef (ncid,'psi' , NCFLOAT,3,dims,iret)
      pressid = ncvdef (ncid,'P'   , NCFLOAT,3,dims,iret)
      topoid  = ncvdef (ncid,'topo', NCFLOAT,2,dims,iret)
c
      dims    = (/Lon_udim,lat_udim,timedim,0/)
      fid     = ncvdef (ncid,'f'     , NCFLOAT,2,dims,iret)
      topouid = ncvdef (ncid,'topo_u', NCFLOAT,2,dims,iret)
      uid     = ncvdef (ncid,'u'     , NCFLOAT,3,dims,iret)
      vid     = ncvdef (ncid,'v'     , NCFLOAT,3,dims,iret)
      tauxid  = ncvdef (ncid,'taux'  , NCFLOAT,3,dims,iret)
      tauyid  = ncvdef (ncid,'tauy'  , NCFLOAT,3,dims,iret)

      dims  = (/Lon_tdim,lat_tdim,order_dim,timedim/)
      Gid   = ncvdef (ncid,'G', NCFLOAT,4,dims,iret)

      dims  = (/Lon_udim,lat_udim,order_dim,timedim/)
      ubid  = ncvdef (ncid,'ub', NCFLOAT,4,dims,iret)
      vbid  = ncvdef (ncid,'vb', NCFLOAT,4,dims,iret)

      keid  = ncvdef (ncid,'ke', NCFLOAT,1,timedim,iret)
      ekid  = ncvdef (ncid,'ek', NCFLOAT,1,timedim,iret)
c
c     assign attributes
c
      name = 'Longitude on T grid';k=len_trim(name)
      call ncaptc(ncid, Lon_tid, 'long_name', NCCHAR, k, name, iret) 
      unit = 'degrees_W ';k=len_trim(unit)
      call ncaptc(ncid, Lon_tid, 'units',     NCCHAR, k, unit, iret) 
c      
      name = 'Longitude on U grid';k=len_trim(name)
      call ncaptc(ncid, Lon_uid, 'long_name', NCCHAR, k, name, iret) 
      unit = 'degrees_W';k=len_trim(unit)
      call ncaptc(ncid, Lon_uid, 'units',     NCCHAR, k, unit, iret) 
c      
      name = 'Latitude on T grid';k=len_trim(name)
      call ncaptc(ncid, Lat_tid, 'long_name', NCCHAR, k, name, iret) 
      unit = 'degrees_N ';k=len_trim(unit)
      call ncaptc(ncid, Lat_tid, 'units',     NCCHAR, k, unit, iret) 
c      
      name = 'Latitude on U grid';k=len_trim(name)
      call ncaptc(ncid, Lat_uid, 'long_name', NCCHAR, k, name, iret) 
      unit = 'degrees_N';k=len_trim(unit)
      call ncaptc(ncid, Lat_uid, 'units',     NCCHAR, k, unit, iret) 
c      
      name = 'Order';k=len_trim(name)
      call ncaptc(ncid, order_id, 'long_name', NCCHAR, k, name, iret) 
      unit = 'index';k=len_trim(unit)
      call ncaptc(ncid, order_id, 'units',     NCCHAR, k, unit, iret) 
c      
      name = 'Time';k=len_trim(name)
      call ncaptc(ncid,Timeid, 'long_name', NCCHAR, k, name, iret) 
      unit = 'days';k=len_trim(unit)
      call ncaptc(ncid,Timeid, 'units',     NCCHAR, k, unit, iret) 
      call ncaptc(ncid,Timeid,'time_origin',NCCHAR, 20,
     &  '31-DEC-1899 00:00:00', iret)
c
      name = 'Zonal Transport'
      unit = 'm^2/s'
      call dvcdf(ncid,uid,name,unit,spval)

      name = 'Meridional Transport'
      unit = 'm^2/s'
      call dvcdf(ncid,vid,name,unit,spval)

      name = 'Meridional Wind Stress'
      unit = 'N/m^2'
      call dvcdf(ncid,tauyid,name,unit,spval)
c
      name = 'Zonal Wind Stress'
      unit = 'N/m^2'
      call dvcdf(ncid,tauxid,name,unit,spval)
c
      if (write_modes) then
       name = 'Baroclinic (flat bottom) density modes'
      else
       name = 'Vertical density Moments'
      endif
      unit = 'm^3/s^2'
      call dvcdf(ncid,Gid,name,unit,spval)
c
      name = 'Bottom pressure'
      unit = 'bar'
      call dvcdf(ncid,pressid,name,unit,spval)
c
      name = 'Coriolis Parameter'
      unit = '1/s'
      call dvcdf(ncid,fid,name,unit,spval)
c
      name = 'Barotropic Streamfunction'
      unit = 'Sv'
      call dvcdf(ncid,psiid,name,unit,spval)
c
      name = 'Zonal barocl. velocity moments'
      unit = 'm^4/s'
      call dvcdf(ncid,ubid,name,unit,spval)
c      
      name = 'Meridional barocl. velocity moments'
      unit = 'm^4/s'
      call dvcdf(ncid,vbid,name,unit,spval)
c      
      name = 'Depth of T-grid points'
      unit = 'm'
      call dvcdf(ncid,topoid,name,unit,spval)
c      
      name = 'Depth of U-grid points'
      unit = 'm'
      call dvcdf(ncid,topouid,name,unit,spval)
c      
      name = 'Basin averaged barotr. kinetic energy'
      unit = 'm^2/s^2'
      call dvcdf(ncid,keid,name,unit,spval)
c      
      name = 'Basin averaged potential energy'
      unit = 'm^3/s^2'
      call dvcdf(ncid,ekid,name,unit,spval)
c      
      text='BARBI I Snapshot'
      call ncaptc(ncid, NCGLOBAL, 'title',   NCCHAR, 80, text, iret)
      text='converted to NetCDF during model integration '
      call ncaptc(ncid, NCGLOBAL, 'history', NCCHAR, 80, text, iret)
      write(text,'("Horizontal viscosity = ",e8.2," m^2/s"'//
     &     '," vertical viscosity = ",e8.2," m^2/s")') Am,Av
      call ncaptc(ncid, NCGLOBAL, 'Viscosity', NCCHAR, 80,text,iret)
      write(text,'("Horizontal diffusivity = ",e8.2," m^2/s")') Ah
      call ncaptc(ncid, NCGLOBAL, 'Diffusivity', NCCHAR,80,text,iret)
      write(text,'("Time step = ",e8.2," s, N_0 = ",e8.2," 1/s")') dt,N0
      call ncaptc(ncid, NCGLOBAL, 'Time_step', NCCHAR,80,text,iret)
      call ncendf(ncid, iret)
c
      var(1:imt,1)=xt
      call ncvpt(ncid, Lon_tid, 1, imt, var, iret)
      var(1:imt,1)=xu
      call ncvpt(ncid, Lon_uid, 1, imt, var, iret)
      var(1:jmt,1)=yt
      call ncvpt(ncid, Lat_tid, 1, jmt, var, iret)
      var(1:jmt,1)=yu
      call ncvpt(ncid, Lat_uid, 1, jmt, var, iret)
      corner(1) = 1
      edges(1) = n_order/2+1
      do k=1,n_order/2+1
       var(k,1)=k*2-1
      enddo
      call ncvpt(ncid, order_id, corner, edges, var, iret)
      Corner = 1
      edges = (/imt,jmt,1,1/)
      var=h
      call ncvpt(ncid, topoid, corner, edges, var, iret)
      var=hu
      call ncvpt(ncid, topouid, corner, edges, var, iret)
      var= cori(:,:,1)
      where( umask == 0. ) var = spval
      call ncvpt(ncid, fid, corner, edges, var, iret)
      call ncclos (ncid, iret)


      end subroutine def_snap



      subroutine dvcdf(ncid,varid,name,unit,spval)
c=======================================================================
c     define some standard attributes of variable varid 
c     in NetCDF file ncid 
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      implicit none
      integer ncid,varid,iret
      character (len=*) :: name, unit
      real (kind=4) spval
      include "netcdf.inc"
      call ncaptc(ncid,varid, 'long_name', NCCHAR,
     &            len_trim(name) , name, iret) 
      call ncaptc(ncid,varid, 'units',     NCCHAR,
     &            len_trim(unit), unit, iret) 
      call ncapt (ncid,varid, 'missing_value',NCFLOAT,1,spval,iret)
      call ncapt (ncid,varid, '_FillValue', NCFLOAT, 1,spval, iret)
      end subroutine dvcdf

c
c-----------------------------------------------------------------------
c     Conjugate Gradient Poisson Solver taken from MOM2.1
c
c     author:      Charles Goldberg        e-mail: chg@gfdl.gov
c
c     based on the preconditioned conjugate gradient algorithm given in:
c
c     A Reformulation and Implementation of the Bryan-Cox-Semtner
c     Ocean Model on the Connection Machine
c     J.K. Dukowicz, R.D. Smith, and R.C. Malone
c     Journal of Atmospheric and Oceanic Technology
c     Vol 10. No. 2 April 1993
c
c     Note: needs to be initialized by init_congrad
c           to calculate island integral paths.
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c-----------------------------------------------------------------------
c
      module congrad_module
      implicit none
      integer :: imt,jmt,imain
      integer :: mnisle,maxipp,nisle
      logical, allocatable :: imask(:)
      integer, allocatable :: iperm(:),jperm(:)
      integer, allocatable :: iofs(:),nippts(:)
      integer, allocatable :: map(:,:)
      logical :: cyclic
      end module congrad_module


      subroutine init_congrad(imt_in,jmt_in,tmask,
     & cyclic_in, enable_obc_north,enable_obc_south,
     & enable_obc_west,enable_obc_east) 
      use island_module
      use congrad_module
      implicit none
      integer :: imt_in,jmt_in,kmt(imt_in,jmt_in),isle
      real(kind=8) :: tmask(imt_in,jmt_in)
      logical :: cyclic_in,enable_obc_north,enable_obc_south
      logical :: enable_obc_west,enable_obc_east

      print*,' initializing the poisson solver'

      imt=imt_in; jmt=jmt_in; cyclic = cyclic_in

      mnisle=10
      maxipp =100000
      allocate( imask(-mnisle:mnisle) )
      allocate( iperm(maxipp),jperm(maxipp) )
      allocate( iofs(mnisle),nippts(mnisle) )
      allocate( map(imt,jmt) )

      kmt=tmask
      call isleperim (kmt, map, iperm, jperm, iofs, nippts, nisle,
     & imt, jmt, mnisle, maxipp,0,cyclic, 
     & enable_obc_north,enable_obc_south,
     & enable_obc_west,enable_obc_east,.false.)  ! chamge kmt mask

      do isle=-mnisle,mnisle
        if (isle .ge. 0 .and. isle .le. nisle) then
          imask(isle) = .true.
        else
          imask(isle) = .false.
        end if
      end do
      print*,' done, here comes the land/sea mask:'
      call showmap(map,imt,jmt)
      imain=1
      end subroutine init_congrad


      subroutine set_cyclic (v)
      use congrad_module
      implicit none
      real (kind=8) :: v(imt,jmt)
      if (cyclic) then
       v(1,:)   = v(imt-1,:)
       v(imt,:) = v(2,:)
      endif
      end subroutine set_cyclic


      subroutine congrad(cf,dpsi,forc,res,
     &    epsilon,iterations,estimated_error,islands)
c     solve   A * dpsi = forc for dpsi
      use congrad_module
      implicit none
      real(kind=8), dimension(imt,jmt,-1:1,-1:1) :: cf
      real(kind=8), dimension(imt,jmt) :: dpsi,res,forc
      real(kind=8), dimension(imt,jmt) :: Z,Zres,As,s

      logical converged,diverged, islands
      integer iterations,max_iterations,k,i,j
      real(kind=8) epsilon,estimated_error,convergence_rate
      real(kind=8) Zresmax,betakm1,betak,betak_min,smax
      real(kind=8) alpha,step,betaquot,s_dot_as,step1,cfactor,dpsi1

      Z=0.; Zres=0.; As=0.; s=0.

      max_iterations=max(imt,jmt)*50

      call set_cyclic(dpsi)
c-----------------------------------------------------------------------
c     make approximate inverse operator Z (always even symmetry)
c-----------------------------------------------------------------------
c
      call make_inv (cf, Z, islands )
      call set_cyclic(Z)
c
c-----------------------------------------------------------------------
c     res(0)  = forc - A * dpsi(0)
c     impose cyclic and/or symmetry conditions on res(i,j)
c-----------------------------------------------------------------------
c
      call op9_vec(cf, dpsi, res)
      res = forc - res
      call set_cyclic(res)
c
c-----------------------------------------------------------------------
c     Zres(k-1) = Z * res(k-1)
c     see if guess is a solution, bail out to avoid division by zero
c-----------------------------------------------------------------------
c
      k = 0
      diverged=.false.

      call inv_op(Z, res, Zres, islands)
      call set_cyclic(Zres)
c
c
      Zresmax = maxval(abs(Zres))
c
c       Assume convergence rate of 0.99 to extrapolate error
c
      if (100.0 * Zresmax .lt. epsilon) then
	  estimated_error = 100.0 * Zresmax 
	  goto 101
      endif
c
c-----------------------------------------------------------------------
c     beta(0) = 1
c     s(0)    = zerovector()
c-----------------------------------------------------------------------
c
      betakm1 = 1.0
      s=0.
c
c-----------------------------------------------------------------------
c     begin iteration loop
c-----------------------------------------------------------------------
c
      do k = 1,max_iterations
c
c-----------------------------------------------------------------------
c       Zres(k-1) = Z * res(k-1)
c-----------------------------------------------------------------------
c
        call inv_op( Z, res, Zres, islands)
        call set_cyclic(Zres)

c-----------------------------------------------------------------------
c       beta(k)   = res(k-1) * Zres(k-1)
c-----------------------------------------------------------------------
c
        call dot2(betak,Zres, res)

        if (k .eq. 1) then
          betak_min = abs(betak)
	elseif (k .gt. 2) then
          betak_min = min(betak_min, abs(betak))
          if (abs(betak) .gt. 100.0*betak_min) then
	    write (6,'(/a/a/)')
     &      'WARNING: conjugate gradient terminated because correction'
     &,     '         steps are diverging. Probable cause...roundoff'
            print*,'k=',k
            smax = maxval(abs(s))
            step = abs(alpha) * smax
	    estimated_error=step*convergence_rate/(1.0-convergence_rate)
            diverged=.true.
	    go to 101
	  endif
	endif
c
c-----------------------------------------------------------------------
c       s(k)      = Zres(k-1) + (beta(k)/beta(k-1)) * s(k-1)
c-----------------------------------------------------------------------
c
        betaquot = betak/betakm1
        s = Zres + betaquot * s
c
c-----------------------------------------------------------------------
c       As(k)     = A * s(k)
c-----------------------------------------------------------------------
c

        call op9_vec(cf, s, As)
        call set_cyclic(As)
c
c-----------------------------------------------------------------------
c       If s=0 then the division for alpha(k) gives a float exception.
c       Assume convergence rate of 0.99 to extrapolate error.
c       Also assume alpha(k) ~ 1.
c-----------------------------------------------------------------------
c
        call dot2(s_dot_As ,s, As)

        if ((abs(s_dot_As) .lt. abs(betak)*1.e-10).or.
     &              ( s_dot_as == 0.)) then
          smax = maxval(abs(s))
	  estimated_error = 100.0 * smax 
	  goto 101
	endif
c
c-----------------------------------------------------------------------
c       alpha(k)  = beta(k) / (s(k) * As(k))
c-----------------------------------------------------------------------
c
        alpha = betak / s_dot_As
c
c-----------------------------------------------------------------------
c       update values:
c       dpsi(k)   = dpsi(k-1) + alpha(k) * s(k)
c       res(k)    = res(k-1) - alpha(k) * As(k)
c-----------------------------------------------------------------------
c
        dpsi  = dpsi + alpha * s
        res   = res  - alpha * As


        if (islands) call avg_dist (res)
        call set_cyclic(res)
c
        smax = maxval(abs(s))
c
c-----------------------------------------------------------------------
c       test for convergence
c       if (estimated_error) < epsilon) exit
c-----------------------------------------------------------------------
c
        step = abs(alpha) * smax
c        print*,'step=',step,' step1=',step1
        if (k .eq. 1) then
          step1 = step
          estimated_error = step
          if (step .lt. epsilon) goto 101
        else if (step .lt. epsilon) then
          if (step == 0) then
            cfactor=-39.
          else  
           cfactor = log(step/step1)
          endif
          convergence_rate = exp(cfactor/(k-1))
	  estimated_error = step*convergence_rate/(1.0-convergence_rate)
          if (estimated_error .lt. epsilon) goto 101
        end if
c
        betakm1 = betak
c
      end do
c
c-----------------------------------------------------------------------
c     end of iteration loop
c-----------------------------------------------------------------------
c
  101 continue
      if ((k .gt. max_iterations).or.(diverged)) then
        cfactor = log(step/step1)
        convergence_rate = exp(cfactor/(k-1))
	estimated_error = step*convergence_rate/(1.0-convergence_rate)
        converged = .false.
      else
        converged = .true.
      end if

      iterations = k
c
c-----------------------------------------------------------------------
c     return the last increment of dpsi in the argument res
c-----------------------------------------------------------------------
c
      if (iterations .eq. 0) then
        res = Zres
      else
        res = alpha * s
      endif

      if (islands) then
       dpsi1 = dpsi(iperm(iofs(imain)+1), jperm(iofs(imain)+1))
       do i=1,imt
        do j=1,jmt
          if (map(i,j) .le. 0) then
            dpsi(i,j) = dpsi(i,j) - dpsi1
          end if
        end do
       end do
      endif

      end subroutine congrad


c
c=======================================================================
c
c     M A T R I X   M O D U L E   F O R   C O N G R A D
c
c=======================================================================
c

      subroutine dot2(sum,a,b)
      use congrad_module
      implicit none
      real(kind=8) :: a(imt,jmt),b(imt,jmt),sum
      integer i,j
c
      sum=0.
      do j=1,jmt
       do i=2,imt-1
         sum=sum+a(i,j)*b(i,j)
       enddo
      enddo
      end subroutine dot2

      subroutine op9_vec(cf, dpsi, res)
c
c                       res = A * dpsi
c
c     this subroutine does not collect the terms of the true value
c     of res(isle) = sum (res(i,j)).  the contributions to the sum
c     remain distributed among the T cells (i,j) that form the
c     ocean perimeter of land_mass(isle).
c
c     at present, borders are not computed [i=1 or imt] [j=1 or jmt]
c
      use congrad_module
      implicit none
      real(kind=8) cf(imt,jmt,-1:1,-1:1), dpsi(imt,jmt),res(imt,jmt)
      integer i,j
c
      do j=2,jmt-1
        do i=2,imt-1
          res(i,j) =
     &               cf(i,j,-1,-1) * dpsi(i-1,j-1) +
     &               cf(i,j, 0,-1) * dpsi(i  ,j-1) +
     &               cf(i,j, 1,-1) * dpsi(i+1,j-1)
        end do
        do i=2,imt-1
          res(i,j) = res(i,j) +
     &               cf(i,j,-1, 0) * dpsi(i-1,j  ) +
     &               cf(i,j, 0, 0) * dpsi(i  ,j  ) +
     &               cf(i,j, 1, 0) * dpsi(i+1,j  )
        end do
        do i=2,imt-1
          res(i,j) = res(i,j) +
     &               cf(i,j,-1, 1) * dpsi(i-1,j+1) +
     &               cf(i,j, 0, 1) * dpsi(i  ,j+1) +
     &               cf(i,j, 1, 1) * dpsi(i+1,j+1)
        end do
      end do
      end subroutine op9_vec


      subroutine inv_op( Z, res, Zres, islands)
c
c     apply and approximate inverse Z or the operator A
c
c     res is type(res_type), i.e., perimeter values res(isle)
c         are the sum of the distributed contributions res(i,j)
c     Zres is type(dpsi_type), i.e., perimeter values Zres(isle)
c         must be replicated at each perimeter point Zres(i,j)
c
c     borders  of Zres [i=1 or imt] [j=1 or jmt] must be defined
c     and must satisfy cyclic and/or symmetry, if defined.
c
c     currently, Z is diagonal:  Z(ij) = 1/A(ij)
c     and is stored in type(dpsi_type) format, i.e., Z(isle) is
c     replicated and stored in each Z(i,j) in the perimeter of
c     land_mass(isle).
c
      use congrad_module
      implicit none
      real(kind=8) Z(imt,jmt), res(imt,jmt), Zres(imt,jmt)
      logical islands
c
      Zres = Z * res
c
c     sum contributions to Zres(isle)
c     distribute Zres(isle) to all perimeter points
      if (islands) call sum_dist (Zres)
c
      end subroutine inv_op



      subroutine make_inv (cf, Z, islands)
c
c     construct an approximate inverse Z to A
c
c     Z will be diagonal:  Z(ij) = 1/A(ij)
c     and values for ocean perimeter entries Z(isle) will be replicated
c     at all T cells Z(i,j) in the ocean perimeter of land_mass(isle).
c
c     T cells (i,j) for which there is no diagonal coefficient
c     i.e., A(ij)=A(i,j)=0, are masked off by assigning Z(i,j)=0.
c     there are effectively no equations and no variables dpsi(i,j)
c     at these points.
c
c
      use congrad_module
      implicit none
      real (kind=8)cf(imt,jmt,-1:1,-1:1), Z(imt,jmt)
      logical :: islands
      integer i,j,isle,n
c
c     copy diagonal coefficients of A to Z
c
      Z = cf(:,:,0,0)
c
c     for each land_mass(isle),
c     sum the contributions to cfdiag(isle)=A(isle,isle)
c     now stored in Z(i,j) at ocean perimeter T cells and replicate
c     the sum in all Z(i,j) for which (i,j) is in ocean perimeter
c     of land_mass(isle).
c
      if (islands) call sum_dist (Z)
c
c     now invert Z
c
      do j=1,jmt
        do i=1,imt
          if (Z(i,j) .ne. 0.0) then
            Z(i,j) = 1./Z(i,j)
          else
            Z(i,j) = 0.0
          end if
        end do
      end do
c
c     make inverse zero on island perimeters that are not integrated
c
      if (islands) then
       do isle=1,nisle
        if (.not. imask(isle)) then
          do n=1,nippts(isle)
            i = iperm(iofs(isle)+n)
            j = jperm(iofs(isle)+n)
            Z(i,j) = 0.0
          end do
        end if
       end do
      endif
c
      end subroutine make_inv



      subroutine sum_dist (Zres)
c
c     sum contributions to Zres(isle)
c     distribute Zres(isle) to all perimeter points
c
c     this subroutine converts a type(res_type) vector with
c     distributed contributions to perimeter values
c        Zres(isle) = sum (Zres(i,j))
c     into a type (dpsi_type) vector with replicated values
c     for land_mass perimeters
c        Zres(isle) = Zres(i,j)
c     for all (i,j) in the ocean perimeter of land_mass(isle).
c
      use congrad_module
      implicit none
      real(kind=8) Zres(imt,jmt), Zresisle(mnisle)
      integer i,j,isle,n
c
c     sum contributions to Zres(isle)
c
         do isle=1,nisle
           if (imask(isle)) then
             Zresisle(isle) = 0.0
             do n=1,nippts(isle)
               i = iperm(iofs(isle)+n)
               j = jperm(iofs(isle)+n)
               Zresisle(isle) = Zresisle(isle) + Zres(i,j)
             end do
           end if
         end do
c
c     distribute Zres(isle) to all perimeter points
c
         do isle=1,nisle
           if (imask(isle)) then
             do n=1,nippts(isle)
               i = iperm(iofs(isle)+n)
               j = jperm(iofs(isle)+n)
               Zres(i,j) = Zresisle(isle)
             end do
           end if
         end do
      end subroutine sum_dist


      subroutine avg_dist (Zres)
c
c     avg contributions to Zres(isle)
c     distribute Zres(isle) to all perimeter points
c
c     this subroutine converts a type(res_type) vector with
c     distributed contributions to perimeter values
c        Zres(isle) = avg (Zres(i,j))
c     into a type (dpsi_type) vector with replicated values
c     for land_mass perimeters
c        Zres(isle) = Zres(i,j)
c     for all (i,j) in the ocean perimeter of land_mass(isle).
c
c
      use congrad_module
      implicit none
      real(kind=8) Zres(imt,jmt), Zresisle(mnisle)
      integer i,j,isle,n
c
c     avg contributions to Zres(isle)
c
      do isle=1,nisle
        if (imask(isle)) then
          Zresisle(isle) = 0.0
          do n=1,nippts(isle)
            i = iperm(iofs(isle)+n)
            j = jperm(iofs(isle)+n)
            Zresisle(isle) = Zresisle(isle) + Zres(i,j)
c            if (isle>1) print*,isle,i,j,Zres(i,j),Zresisle(isle)
          end do
        end if
      end do
c
c     distribute Zres(isle) to all perimeter points
c
      do isle=1,nisle
        if (imask(isle)) then
          Zresisle(isle) = Zresisle(isle)/nippts(isle)
c          print*,isle,nippts(isle),Zresisle(isle)
          do n=1,nippts(isle)
            i = iperm(iofs(isle)+n)
            j = jperm(iofs(isle)+n)
            Zres(i,j) = Zresisle(isle)
          end do
        end if
      end do
      end subroutine avg_dist

c
c-----------------------------------------------------------------------
c     file contains barotropic part of BARBI
c
c-----------------------------------------------------------------------
c
      subroutine tropic()
c=======================================================================
c     Integrate the barotropic velocity 
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      real(kind=8) :: diff_fe(imt,jmt),fxa,fxb,t1,t2,diff_fn(imt,jmt)
      integer      :: i,j,n
c
c-----------------------------------------------------------------------
c     statement functions for advection and diffusion
c-----------------------------------------------------------------------
c
      real (kind=8) :: diff_ux,diff_uy,diff_metric
      DIFF_Ux(i,j) = hur(i,j)*(diff_fe(i,j)-diff_fe(i-1,j))*csudxur(i,j)
      DIFF_Uy(i,j) = hur(i,j)*(diff_fn(i,j) - diff_fn(i,j-1))*csudyur(j)
      DIFF_metric(i,j,n) = am3(j)*u(i,j,n,taum1)+am4(j,n)*dxmetr(i)
     &                    *(u(i+1,j,3-n,taum1) - u(i-1,j,3-n,taum1))
c
c-----------------------------------------------------------------------
c     calculate the gradient of G_1 to force the barotropic mode
c-----------------------------------------------------------------------
c
      grad_E=0.
      do j=1,jmt-1
        fxa  = csur(j)
        fxb  = dyu2r(j)
        do i=1,imt-1
          t1  = G(i+1,j+1,1,tau) - G(i, j,1,tau)
          t2  = G(i,j+1,1,tau) - G(i+1,j,1,tau)
          grad_E(i,j,1) = (t1-t2)*fxa*dxu2r(i)*hur(i,j)
          grad_E(i,j,2) = (t1+t2)*fxb*hur(i,j)
        enddo
      enddo
      if (cyclic) then
       grad_E(1,:,:)   = grad_E(imt-1,:,:)
       grad_E(imt,:,:) = grad_E(2,:,:)
      endif
c
c-----------------------------------------------------------------------
c     loop over the velocity components and solve for forcing
c     of the streamfunction. We are able to neglect the bottom
c     pressure here,  since it does not force the streamfunction.
c     Velocity is calculated afterwards from the stramfunction.
c     Note that velocities are vertical averages here.
c-----------------------------------------------------------------------
c

      do n=1,2

c       diffusive flux across east face of "u" cell
        do j=2,jmt-1
         do i=1,imt-1
          diff_fe(i,j)=am_csudxtr(i,j)
     &            *(u(i+1,j,n,taum1)-u(i,j,n,taum1))
     &            *(h(i+1,j)+h(i+1,j+1))/2.
         enddo
        enddo
c       diffusive flux across north face of "u" cell
        do j=1,jmt-1
         fxa = am*cst(j+1)*dytr(j+1)
         do i=2,imt-1
          diff_fn(i,j) = fxa* (u(i,j+1,n,taum1)-u(i,j,n,taum1))*
     &                          (h(i,j+1)+h(i+1,j+1))/2.
         enddo
        enddo
c
c-----------------------------------------------------------------------
c       calculate the forcing for the streamfunction
c-----------------------------------------------------------------------
c
        do j=2,jmt-1
         do i=2,imt-1
	  zu(i,j,n) = (
     &     +DIFF_Ux(i,j)+DIFF_Uy(i,j) 
     &       + DIFF_metric(i,j,n)
     &     +cori(i,j,n)*u(i,j,3-n,tau) 
     &     -grad_E(i,j,n)
     &     +wind(i,j,n)*hur(i,j))*umask(i,j)
         enddo
        enddo
        if (cyclic) then
         zu(1,:,n)   = zu(imt-1,:,n)
         zu(imt,:,n) = zu(2,:,n)
        endif
      enddo
c
c-----------------------------------------------------------------------
c     Now solve for the streamfunction and get velocites again
c-----------------------------------------------------------------------
c
      call streamfunction
      end subroutine tropic




      subroutine streamfunction
c=======================================================================
c    Construct the forcing for the streamfunction and solve for it
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      real (kind=8) diag1,diag0, coef(imt,jmt,-1:1,-1:1)
      real (kind=8) forc(imt,jmt),res(imt,jmt)
      real (kind=8) eps,error,fxa,grad_p(imt,jmt,2)
      integer i,j,isle
      real (kind=8) c1ps(imt),c1pn(imt),c1pw(jmt),c1pe(jmt)

      coef=0.; forc=0.; res=0.
      if (eulerfore .or. eulerback1) psi(:,:,2) = psi(:,:,1)

      call sfforc(forc)
      if (cyclic) then
        forc(1,:)   = forc(imt-1,:)
        forc(imt,:) = forc(2,:)
      endif
      call sfc9pt (coef)

      fxa=1. ; if (eulerfore.or.eulerback1.or.eulerback2) fxa=.5
      res = dpsi; dpsi = fxa*(2.*dpsi- guess); guess=res   
      call congrad(coef,dpsi,forc,res,eps_solver,mscans,error,.true.)
      if (cyclic) then
        dpsi(1,:)   = dpsi(imt-1,:)
        dpsi(imt,:) = dpsi(2,:)
      endif
c
c     calculate first the phase velocities for psi
c
      call phase_velocities_psi(c1ps,c1pn,c1pw,c1pe)
c
      if (eulerback2) then
        psi(:,:,1)=psi(:,:,2)+dpsi
      else
        res(:,:)    = psi(:,:,2) + dpsi
        psi(:,:,2)  = psi(:,:,1)
        psi(:,:,1)  = res(:,:)
      endif

      call addobcpsi(c1ps,c1pn,c1pw,c1pe)

      do j=2,jmt-1
       do i=2,imt-1
        diag1       = psi(i+1,j+1,1) - psi(i  ,j,1)
        diag0       = psi(i  ,j+1,1) - psi(i+1,j,1)
	u(i,j,1,taup1)  = -(diag1+diag0)*dyu2r(j)
	u(i,j,2,taup1)  =  (diag1-diag0)*dxu2r(i)*csur(j)
       enddo
      enddo
      u(:,:,1,taup1) = u(:,:,1,taup1)*umask*hur
      u(:,:,2,taup1) = u(:,:,2,taup1)*umask*hur
      if (cyclic) then
        u(1,:,:,taup1)   = u(imt-1,:,:,taup1)
        u(imt,:,:,taup1) = u(2,:,:,taup1)
      endif
      if (enable_obc_south) u(:,1,:,taup1) = u(:,2,:,taup1)
      if (enable_obc_north) then
       u(:,jmt-1,:,taup1) = u(:,jmt-2,:,taup1)
       u(:,jmt  ,:,taup1) = u(:,jmt-2,:,taup1)
      endif
      if (enable_obc_west)  u(1,:,:,taup1) = u(2,:,:,taup1)
      if (enable_obc_east) then
        u(imt  ,:,:,taup1) = u(imt-2,:,:,taup1)
        u(imt-1,:,:,taup1) = u(imt-2,:,:,taup1)
      endif
c
c     now solve for the bottom pressure
c
      if (snapshot_time_step) then
       grad_p(:,:,1) = (U(:,:,1,taup1)-U(:,:,1,taum1))/c2dt-zu(:,:,1)
       grad_p(:,:,2) = (U(:,:,2,taup1)-U(:,:,2,taum1))/c2dt-zu(:,:,2)
       if (cyclic) then
        grad_p(1,:,:)   = grad_p(imt-1,:,:)
        grad_p(imt,:,:) = grad_p(2,:,:)
       endif

       coef=0.; forc=0.; res=0.; press=0.
       call spforc (grad_p, forc )
       if (cyclic) then
        forc(1,:)   = forc(imt-1,:)
        forc(imt,:) = forc(2,:)
       endif
       call spc9pt (coef)
       call congrad(coef,press,forc,res,eps_solver_p,mscans_p,
     &              error,.false.)
       if (cyclic) then
        press(1,:)   = press(imt-1,:)
        press(imt,:) = press(2,:)
       endif
      endif
      end subroutine streamfunction



      subroutine phase_velocities_psi(c1ps,c1pn,c1pw,c1pe)
c=======================================================================
c     calculate phase velocities for psi
c     Orlanski radiation condition (passive open boundary)   
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      real (kind=8) var,var1,c1ps(imt),c1pn(imt),c1pw(jmt),c1pe(jmt)
      integer i,j
      if (enable_obc_south ) then
       var=-dyu(3)/dt
       do 4030 i=1,imt
         var1=psi(i,4,2)-psi(i,3,2)
         if (var1== 0.) then
           c1ps(i)=var
           goto 4030
         endif
         c1ps(i)=var*(psi(i,3,1)-psi(i,3,2))/var1
         if (c1ps(i).ge. 0.) c1ps(i)=0.
         if (c1ps(i).lt.var) c1ps(i)=var
4030   continue
      endif
c
      if (enable_obc_north) then
       var=dyu(jmt-2)/dt
       do 4031 i=1,imt
         var1=psi(i,jmt-2,2)-psi(i,jmt-3,2)
         if (var1.eq.0.) then
           c1pn(i)=var
           goto 4031
         endif
         c1pn(i)=-var*(psi(i,jmt-2,1)-psi(i,jmt-2,2))/var1
         if (c1pn(i).le. 0.) c1pn(i)=0.
         if (c1pn(i).gt.var) c1pn(i)=var
4031   continue
      endif
c
      if (enable_obc_west) then
       do 4032 j=1,jmt
         var=-dxu(3)*csu(j)/dt
         var1=psi(4,j,2)-psi(3,j,2)
         if (var1.eq.0.) then
           c1pw(j)=var
           goto 4032
         endif
         c1pw(j)=var*(psi(3,j,1)-psi(3,j,2))/var1
         if (c1pw(j).ge. 0.) c1pw(j)=0.
         if (c1pw(j).lt.var) c1pw(j)=var
4032   continue
      endif
c
      if (enable_obc_east) then
       do 4033 j=1,jmt
         var=dxu(imt-2)*csu(j)/dt
         var1=psi(imt-2,j,2)-psi(imt-3,j,2)
         if (var1.eq.0.) then
           c1pe(j)=var
           goto 4033
         endif
         c1pe(j)=-var*(psi(imt-2,j,1)-psi(imt-2,j,2))/var1
         if (c1pe(j).le. 0.) c1pe(j)=0.
         if (c1pe(j).gt.var) c1pe(j)=var
4033   continue
      endif
      end subroutine phase_velocities_psi



      subroutine addobcpsi(c1ps,c1pn,c1pw,c1pe)
c=======================================================================
c     passive Orlanski radiation condition (passive open boundary)   
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      integer i,j
      real (kind=8) :: c1ps(imt),c1pn(imt),c1pw(jmt),c1pe(jmt)
      if (enable_obc_south) then
        do i=2,imt-1
         psi(i,2,1) =psi(i,2,2)  - c1ps(i)*dt*dyur(2)
     &                          *(psi(i,3,2)-psi(i,2,2))
         psi(i,1,1) =psi(i,2,1)
        enddo
      endif

      if (enable_obc_north) then
       do i=2,imt-1
         psi(i,jmt-1,1)=psi(i,jmt-1,2)- c1pn(i)*dt*dyur(jmt-1)
     &                          *(psi(i,jmt-1,2)- psi(i,jmt-2,2))
         psi(i,jmt,1)  =psi(i,jmt-1,1)
       enddo
      endif
c
      if (enable_obc_west ) then
       do j=2,jmt-1
         psi(2,j,1)   = psi(2,j,2)
     &                       - c1pw(j)*dt*dxur(2)*csur(j)
     &                       *(psi(3,j,2) -psi(2,j,2))
         psi(1,j,1)   = psi(2,j,1)
       enddo
      endif

      if (enable_obc_east) then
       do j=2,jmt-1
         psi(imt-1,j,1) = psi(imt-1  ,j,2)
     &                    - c1pe(j)*dt*dxur( imt-1 )*csur(j)
     &                    *(psi(imt-1,j,2)- psi(imt-2,j,2))
         psi(imt,j,1)     = psi(imt-1,j,1)
       enddo
      endif
c-----------------------------------------------------------------------
c      call adjust_islands_obc
      end subroutine addobcpsi





      subroutine sfforc (forc)
c
c=======================================================================
c           S T R E A M   F U N C T I O N   F O R C I N G
c=======================================================================
c
      use barbi_module
      implicit none
      real(kind=8), dimension( 0:1, 0:1)     :: cddxu,  cddyu
      real(kind=8), dimension(-1:0,-1:0)     :: cddxt,  cddyt
      real(kind=8), dimension(imt,jmt)       :: ustuff,vstuff,forc
      real(kind=8) p5
      integer i,j,i1,j1,i2,j2

      p5=0.5
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
c
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
c
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
c
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5
c
c-----------------------------------------------------------------------
c     multiply the u eqn by dx*cos, the v eqn by dy, then subtract their 
c     partial differences to eliminate the unknown surface pressure from 
c     the resulting equation
c-----------------------------------------------------------------------
c
      ustuff=0.
      vstuff=0.
      do j=1,jmt-1
        do i=1,imt-1
          ustuff(i,j) = zu(i,j,1)*dxu(i)*csu(j)
          vstuff(i,j) = zu(i,j,2)*dyu(j)
        end do
      end do
c
      forc=0.0
      do j1=-1,0
        do j=2,jmt-1
          do i=2,imt-1
            do i1=-1,0
              forc(i,j) = forc(i,j) 
     &                     - cddyt(i1,j1)*ustuff(i+i1,j+j1)
     &                     + cddxt(i1,j1)*vstuff(i+i1,j+j1)
            end do
          end do
        end do
      end do
c
      end subroutine sfforc




      subroutine spforc (grad_p, forc)
c
c=======================================================================
c           S U R F A C E   P R E S S U R E   F O R C I N G
c     author:      c. h. goldberg      e-mail=> chg@gfdl.gov
c=======================================================================
c
      use barbi_module
      implicit none
      real(kind=8) :: grad_p(imt,jmt,2), forc(imt,jmt)
      real(kind=8), dimension(imt,jmt) :: ustuff, vstuff
      real(kind=8), dimension( 0:1, 0:1)     :: cddxu,  cddyu
      real(kind=8), dimension(-1:0,-1:0)     :: cddxt,  cddyt
      real(kind=8), parameter :: p5=0.5
      integer ::  i,j,i1,j1

      forc = 0.
c
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5;
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5

      do j=1,jmt-1
        do i=1,imt-1
	  ustuff(i,j) = hu(i,j)*grad_p(i,j,1)*dyu(j)
	  vstuff(i,j) = hu(i,j)*grad_p(i,j,2)*dxu(i)*csu(j)
        end do
      end do
c
      do j1=-1,0
	do j=2,jmt-1
	  do i=2,imt-1
             do i1=-1,0
	      forc(i,j) = forc(i,j)
     &                     + cddxt(i1,j1)*ustuff(i+i1,j+j1)
     &                     + cddyt(i1,j1)*vstuff(i+i1,j+j1)
	    end do
	  end do
	end do
      end do
      end subroutine spforc




      subroutine sfc9pt  (coef)
c
c=======================================================================
c     9  P T    C O E F F I C I E N T   I N I T I A L I A Z A T I O N
c     coefficient initialization for 9 point elliptic solvers
c=======================================================================
c
c-----------------------------------------------------------------------
c     generate arrays of coefficients
c     construct coefficients for partial differences. a partial
c     difference in "x" is defined as an "x" difference of a quantity 
c     which is averaged in "y". (and symmetrically for "y" differences).
c     Note that this is an x difference and NOT an x derivitive.
c     partial differences of quantities on the "t" grid are defined on
c     the "u" grid and visa versa.
c     therefore partial differences at: 
c     u/v points (i,j), involve nearby t/s points with subscripts: 
c        (i  ,j+1)    (i+1,j+1)
c        (i  ,j  )    (i+1,j  )
c     t/s points (i,j), involve nearby u/v points with subscripts:
c        (i-1,j  )    (i  ,j  )
c        (i-1,j-1)    (i  ,j-1)
c     thus if qu(i,j) is defined on u/v points, its partial
c     difference ddxqt = ddxt(qu) is defined on t/s points and has the
c     value 
c     ddxqt(i,j) = cddxt(-1,-1)*qu(i-1,j-1) + cddxt(-1,0)*qu(i-1,j+0)
c                + cddxt( 0,-1)*qu(i+0,j-1) + cddxt( 0,0)*qu(i+0,j+0)
c-----------------------------------------------------------------------
c
      use barbi_module
      implicit none
      real(kind=8) :: coef(imt,jmt,-1:1,-1:1),p5=0.5
      real(kind=8), dimension( 0:1, 0:1)     :: cddxu,  cddyu
      real(kind=8), dimension(-1:0,-1:0)     :: cddxt,  cddyt
      real(kind=8), dimension(imt,jmt)       :: ustuff,vstuff
      integer i,j,i1,j1,i2,j2
c
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5
c
c-----------------------------------------------------------------------
c     compute coefficients for all points
c-----------------------------------------------------------------------
c
      ustuff=0.
      vstuff=0.
      do j=1,jmt-1
       do i=1,imt-1
          ustuff(i,j) = dxu(i)*csu(j) / (c2dt*dyu(j)) *hur(i,j) 
          vstuff(i,j) = dyu(j) / (c2dt*dxu(i)*csu(j)) *hur(i,j) 
        end do
      end do
c
c---------------------------------------------------------------------
c     calculate 9 point coefficients
c---------------------------------------------------------------------
c
      coef=0.0
      do j1=0,1
         do j2=-1,0
           do j=2,jmt-1
      do i1=0,1
          do i2=-1,0
                do  i=2,imt-1
                  coef(i,j,i1+i2,j1+j2) = coef(i,j,i1+i2,j1+j2) +
     &               cddyu(i1,j1)*cddyt(i2,j2)*ustuff(i+i2,j+j2)  +
     &               cddxu(i1,j1)*cddxt(i2,j2)*vstuff(i+i2,j+j2)
                end do
              end do
            end do
          end do
        end do
      end do

      end subroutine sfc9pt



      subroutine spc9pt (coef)
c
c=======================================================================
c     S U R F A C E   P R E S S U R E    C O E F F I C I E N T
c     author: c.h. goldberg         e-mail => chg@gfdl.gov
c=======================================================================
c
      use barbi_module
      implicit none

      real(kind=8) :: coef(imt,jmt,-1:1,-1:1)
      real(kind=8) :: ustuff(imt,jmt), vstuff(imt,jmt)
      real(kind=8) :: cddxu(0:1,0:1),   cddyu(0:1,0:1)
      real(kind=8) :: cddxt(-1:0,-1:0), cddyt(-1:0,-1:0)
      real(kind=8), parameter :: p5=0.5
      integer :: i,j,i1,j1,i2,j2
c
      cddxu( 0, 0) = -p5; cddxu( 0, 1) = -p5
      cddxu( 1, 0) =  p5; cddxu( 1, 1) =  p5
      cddxt(-1,-1) = -p5; cddxt(-1, 0) = -p5
      cddxt( 0,-1) =  p5; cddxt( 0, 0) =  p5
      cddyu( 0, 0) = -p5; cddyu( 0, 1) =  p5
      cddyu( 1, 0) = -p5; cddyu( 1, 1) =  p5
      cddyt(-1,-1) = -p5; cddyt(-1, 0) =  p5
      cddyt( 0,-1) = -p5; cddyt( 0, 0) =  p5
c
      coef = 0.0; ustuff = 0.0; vstuff = 0.0
      do i=1,imt-1
        do j=1,jmt-1
          ustuff(i,j) = hu(i,j)*dyu(j)/(dxu(i)*csu(j))
          vstuff(i,j) = hu(i,j)*dxu(i)*csu(j)/dyu(j)
        end do
      end do
c
c     calculate divergence = ddx (ddx (ustuff)) + ddy( ddy (vstuff))
c
      do j1=0,1
        do j2=-1,0
          do j=2,jmt-1
            do i1=0,1
              do i2=-1,0
                do  i=2,imt-1
                  coef(i,j,i1+i2,j1+j2) = coef(i,j,i1+i2,j1+j2)
     &                 + cddxu(i1,j1) * cddxt(i2,j2) * ustuff(i+i2,j+j2)
     &                 + cddyu(i1,j1) * cddyt(i2,j2) * vstuff(i+i2,j+j2)
                end do
              end do
            end do
          end do
        end do
      end do
      end subroutine spc9pt 

c
c-----------------------------------------------------------------------
c     file contains main driver and restart file IO
c
c-----------------------------------------------------------------------
c
      program barbi
c=======================================================================
c     The main driver for BARBI
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      integer :: n
c     setup the model
      call setup
c     loop over time steps; use subr. of time manager for time stepping
 10     call time_step_begin()
c       calculate barotropic advection velocities
        call adv_vel
        do n=1,n_order,2
c        time step baroclinic velocity moments
         call clinic(n)
c        time step density moments
         call moments(n)
        enddo
c       time step barotropic mode
        call tropic()
c       write diagnostics
        call diag()
c       shift time stepping indicees, do evetually a mixing time step
        call time_step_end()
        if (.not. end_of_run .or. eulerback2 ) goto 10
c     end of integration, save restart and stop
      if (write_restart) call write_rest
      print*,' end of integration...'
      stop
      end program barbi


      subroutine read_rest(itt_in)
c=======================================================================
c     read NetCDF restart file for BARBI
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      include "netcdf.inc"
      integer iret,ncid,n,itt_in
      integer ipsiid,iuid,iubid,ivid,ivbid,igid,itid
      integer dims(4), corner(4), edges(4)
      real (kind=4) var(imt,jmt)
      print*,''
      print*,' reading from restart file ',restart_file
      iret=nf_open(restart_file,NF_nowrite,ncid)

      iret= nf_get_att_int(ncid,nf_global,'itt',itt_in)

      iret=nf_inq_varid(ncid,'psi',ipsiid)
      iret=nf_inq_varid(ncid,'u',iuid)
      iret=nf_inq_varid(ncid,'v',ivid)
      iret=nf_inq_varid(ncid,'ub',iubid)
      iret=nf_inq_varid(ncid,'vb',ivbid)
      iret=nf_inq_varid(ncid,'g',igid)

      edges=1
      edges(1)=imt
      edges(2)=jmt
      corner=1
      iret= nf_get_vara_real (ncid,ipsiid,corner,edges,var)
      psi(:,:,2)=var
      iret= nf_get_vara_real (ncid,iuid,corner,edges,var)
      u(:,:,1,0)=var
      iret= nf_get_vara_real (ncid,ivid,corner,edges,var)
      u(:,:,2,0)=var

      corner(3)=2
      iret= nf_get_vara_real (ncid,ipsiid,corner,edges,var)
      psi(:,:,1)=var
      iret= nf_get_vara_real (ncid,iuid,corner,edges,var)
      u(:,:,1,1)=var
      iret= nf_get_vara_real (ncid,ivid,corner,edges,var)
      u(:,:,2,1)=var

      do n=0,n_order
       corner(3)=n+1
       corner(4)=1
       iret= nf_get_vara_real (ncid,igid,corner,edges,var)
       g(:,:,n,0)=var
       iret= nf_get_vara_real (ncid,iubid,corner,edges,var)
       ub(:,:,1,0,n)=var
       iret= nf_get_vara_real (ncid,ivbid,corner,edges,var)
       ub(:,:,2,0,n)=var

       corner(4)=2
       iret= nf_get_vara_real (ncid,igid,corner,edges,var)
       g(:,:,n,1) =var
       iret= nf_get_vara_real (ncid,iubid,corner,edges,var)
       ub(:,:,1,1,n) =var
       iret= nf_get_vara_real (ncid,ivbid,corner,edges,var)
       ub(:,:,2,1,n) =var
      enddo

      call ncclos (ncid, iret)

      print*,'done'
      print*,''
      end subroutine read_rest



      subroutine write_rest()
c=======================================================================
c     write NetCDF restart file for BARBI
c
c                      C.Eden Feb. 2002 (mailto ceden@phys.ocean.dal.ca)
c=======================================================================
      use barbi_module
      implicit none
      include "netcdf.inc"
      integer iret,ncid
      integer ipsiid,iuid,iubid,ivid,ivbid,igid
      integer dims(4), corner(4), edges(4)
      integer lon_dim,lat_dim
      integer order_dim,timedim,n
      real (kind=4) :: var(imt,jmt)
      print*,''
      print*,'  writing to restart file ',restart_file
      ncid = nccre (restart_file, NCCLOB, iret)

      lon_dim  = ncddef(ncid, 'x', imt, iret)
      Lat_dim  = ncddef(ncid, 'y',  jmt, iret)
      order_dim = ncddef(ncid, 'Order',  n_order+1, iret)
      Timedim  = ncddef(ncid, 'Time',2, iret)

      dims(1) = Lon_dim
      dims(2) = Lat_dim
      dims(3) = Timedim
      ipsiid  = ncvdef (ncid,'psi', NCFLOAT,3,dims,iret)
      iuid  = ncvdef (ncid,'u', NCFLOAT,3,dims,iret)
      ivid  = ncvdef (ncid,'v', NCFLOAT,3,dims,iret)
      dims(3) = order_dim
      dims(4) = Timedim
      igid  = ncvdef (ncid,'g', NCFLOAT,4,dims,iret)
      iubid  = ncvdef (ncid,'ub', NCFLOAT,4,dims,iret)
      ivbid  = ncvdef (ncid,'vb', NCFLOAT,4,dims,iret)
      iret= nf_put_att_int(ncid,nf_global,'itt',nf_int,1,itt)

      call ncendf(ncid, iret)
      corner=1
      edges=1
      edges(1)=imt
      edges(2)=jmt
      var= psi(:,:,2)
      iret= nf_put_vara_real (ncid,ipsiid,corner,edges,var)
      var= u(:,:,1,taum1)
      iret= nf_put_vara_real (ncid,iuid,corner,edges,var)
      var= u(:,:,2,taum1)
      iret= nf_put_vara_real (ncid,ivid,corner,edges,var)

      corner(3)=2
      var= psi(:,:,1)
      iret= nf_put_vara_real (ncid,ipsiid,corner,edges,var)
      var= u(:,:,1,tau)
      iret= nf_put_vara_real (ncid,iuid,corner,edges,var)
      var= u(:,:,2,tau)
      iret= nf_put_vara_real (ncid,ivid,corner,edges,var)


      do n=0,n_order
       corner(3)=n+1
       corner(4)=1
       var= g(:,:,n,taum1)
       iret= nf_put_vara_real (ncid,igid,corner,edges,var)
       var= ub(:,:,1,taum1,n)
       iret= nf_put_vara_real (ncid,iubid,corner,edges,var)
       var= ub(:,:,2,taum1,n)
       iret= nf_put_vara_real (ncid,ivbid,corner,edges,var)

       corner(4)=2
       var= g(:,:,n,tau)
       iret= nf_put_vara_real (ncid,igid,corner,edges,var)
       var= ub(:,:,1,tau,n)
       iret= nf_put_vara_real (ncid,iubid,corner,edges,var)
       var= ub(:,:,2,tau,n)
       iret= nf_put_vara_real (ncid,ivbid,corner,edges,var)
      enddo

      call ncclos (ncid, iret)

      print*,'done'
      print*,''
      end subroutine write_rest
